/*
*  This script is used to replace default searchBar's "searchBookmark" function.
*
* Author: Stphane BERTIN
* http://bookmarkdd.mozdev.org
*
*/

// search String within column selected in SearchBar's Menulist
function BddsearchBookmarks(aInput){

    var searchMenuList = document.getElementById("bookmarksPanel");
    if (searchMenuList) {
	if(!UserPrefs.getPref("bool","searchMenuList.showItinSideBar")){
	    document.getElementById('bookmarks-view').searchBookmarks(aInput);
	    return;
	}
    }// else Bookmarkdd.myDump("search-box not found !!");

    //When Panel is opened or menulist changed the default aInput is event and not search-box.value
    if (typeof aInput != "string") {
	aInput = document.getElementById("search-box").value;
    }

    var searchMenu = document.getElementById("search-in-column");
    var searchToolbar = document.getElementById("search-in-columnBar");
    //Avoid error when the menu is in BookmarkPanel whereas showItinSideBar=false
    //if(!searchMenu) return;
    if(searchMenu){
	var selectedColumn = searchMenu.selectedItem.id;
    } else if(searchToolbar){
	var menupopupElements = document.getElementById("popup-in-column");
	var items = menupopupElements.childNodes;
	var selectedColumn = "";
	for(var i=0;i<items.length;i++){
	    var check = items[i].getAttribute('checked')
	    if(check == "true") {
	    	selectedColumn = items[i].id;
	    	//Bookmarkdd.myDump("ItemValue= "+items[i].id);
	    }
	}
	//items[2].checked=true;
    } else return;
    //DEBUG:
    //Bookmarkdd.myDump("selectedColumn= "+selectedColumn);
    var bookmarkView = document.getElementById('bookmarks-view');

    if(!bookmarkView.originalRef)
	bookmarkView.originalRef = bookmarkView.tree.getAttribute("ref");

    if (!aInput){
	bookmarkView.tree.setAttribute("ref", bookmarkView.originalRef);
    } else {
	switch(selectedColumn){
	    case "Name":
		bookmarkView.tree.setAttribute("ref",
		"find:datasource=rdf:bookmarks&match=http://home.netscape.com/NC-rdf#Name&method=contains&text=" + encodeURIComponent(aInput));
		break;
	    case "Location":
		bookmarkView.tree.setAttribute("ref",
		"find:datasource=rdf:bookmarks&match=http://home.netscape.com/NC-rdf#URL&method=contains&text=" + encodeURIComponent(aInput));
		break;
	    case "Description":
		bookmarkView.tree.setAttribute("ref",
		"find:datasource=rdf:bookmarks&match=http://home.netscape.com/NC-rdf#Description&method=contains&text=" + encodeURIComponent(aInput));
		break;
	    case "ShortcutURL":
		bookmarkView.tree.setAttribute("ref",
		"find:datasource=rdf:bookmarks&match=http://home.netscape.com/NC-rdf#ShortcutURL&method=contains&text=" + encodeURIComponent(aInput));
		break;
	    default:
		bookmarkView.tree.setAttribute("ref",
		"find:datasource=rdf:bookmarks&match=http://home.netscape.com/NC-rdf#Name&method=contains&text=" + encodeURIComponent(aInput));
	}
    }
}
